#include <stdio.h>
#define MAXN 10000
#define MAXM 1000000

int m, n;

int edges[MAXN][MAXN];

int main() 
{
  FILE * fin = fopen("swiss.in", "r");
  FILE * fout = fopen("swiss.out", "w");
  fscanf(fin, "%i %i", &n, &m);

  int i;
  int from, to, value;
  for (i=0; i<m; i++) {
    fscanf(fin, "%i %i %i", &from, &to, &value);
    edges[--from][--to] = value;
    edges[to][from] = value;
  }

  
  int best = 0, a, b, c, d; // nas nejlepsi okruh a-b-c-d-a

  int u, v, w, x;

  for (u=0; u<n; u++)
    for (v=0; v<n; v++) {
      if (!edges[u][v]) continue;
      for (w=0; w<n; w++) {
        if (!edges[v][w] || w==u) continue;
        for (x=0; x<n; x++) {
          if (!edges[w][x] || !edges[x][u] || x==v) continue;
          if (edges[u][v] + edges[v][w] + edges[w][x] + edges[x][u] > best) {
            best = edges[u][v] + edges[v][w] + edges[w][x] + edges[x][u];
            a = u; b = v; c = w; d = x;
          }
        }
      }
    }

  if (!best)
    fprintf(fout, "NEEXISTUJE\n");
  else
    fprintf(fout, "%i\n%i %i %i %i %i\n", best, a+1, b+1, c+1, d+1, a+1);

  return 0;
}
